63000 '*************************************************************************
63001 '*                                                                       *
63002 '*                             SWK_BIND.BAS                              *
63003 '*                             ------------                              *
63004 '*                                                                       *
63005 '*                     Binding fr SOUNDWORKER V1.1                      *
63006 '*                                                                       *
63007 '*                        Sprache: OMIKRON.BASIC                         *
63008 '*                                                                       *
63009 '*************************************************************************
63010 '
63011 '
63012 '
63013 '*************************************************************************
63014 '*                                                                       *
63015 '*                               SWK_LOAD                                *
63016 '*                                                                       *
63017 '*                  Eingabe: Filename$                                   *
63018 '*                                                                       *
63019 '*                  Ausgabe:   0 -> erfolgreich geladen                  *
63020 '*                            -1 -> falsche Datei                        *
63021 '*                         sonst -> GEMDOS-Fehlermeldung                 *
63022 '*                                                                       *
63023 '*************************************************************************
63024 '
63025 DEF FN Swk_Load%(Filename$)
63026    '
63027    LOCAL Count%,Handle%,Size%,I%,Swk_Id$
63028    '
63029    Swk_Ptr%L= LPEEK( VARPTR(Filename$))+ LPEEK( SEGPTR +28)
63030    GEMDOS (Handle%,61, HIGH(Swk_Ptr%L), LOW(Swk_Ptr%L),0)
63031    IF Handle%>0 THEN
63032       IF Swk_Adr%L=0 THEN
63033          DIM Swk_Array%(2512)
63034          Swk_Adr%L= LPEEK( VARPTR(Swk_Array%(0)))+ LPEEK( SEGPTR +20)
63035       ENDIF
63036       Size%=5024
63037       GEMDOS (Count%,63,Handle%,0,Size%, HIGH(Swk_Adr%L), LOW(Swk_Adr%L))
63038       GEMDOS (I%,62,Handle%)
63039       IF Count%<>Size% THEN RETURN -1
63040       Swk_Id$="SOUNDWORKER V1.1"
63041       Swk_Ptr%L= LPEEK( VARPTR(Swk_Id$))+ LPEEK( SEGPTR +28)
63042       Handle%=0
63043       FOR I%=0 TO 15 STEP 4
63044          IF LPEEK(Swk_Adr%L+I%)<> LPEEK(Swk_Ptr%L+I%) THEN Handle%=-1
63045       NEXT I%
63046    ENDIF
63047    '
63048 RETURN Handle%
63049 '
63050 '
63051 '
63052 '*************************************************************************
63053 '*                                                                       *
63054 '*                               SWK_START                               *
63055 '*                                                                       *
63056 '*************************************************************************
63057 '
63058 DEF PROC Swk_Start
63059    '
63060    Swk_Ptr%L=Swk_Adr%L+48
63061    XBIOS (,38, HIGH(Swk_Ptr%L), LOW(Swk_Ptr%L))
63062    '
63063 RETURN
63064 '
63065 '
63066 '
63067 '*************************************************************************
63068 '*                                                                       *
63069 '*                               SWK_STOP                                *
63070 '*                                                                       *
63071 '*************************************************************************
63072 '
63073 DEF PROC Swk_Stop
63074    '
63075    Swk_Ptr%L=Swk_Adr%L+52
63076    XBIOS (,38, HIGH(Swk_Ptr%L), LOW(Swk_Ptr%L))
63077    '
63078 RETURN
63079 '
63080 '
63081 '
63082 '*************************************************************************
63083 '*                                                                       *
63084 '*                               SWK_PLAY                                *
63085 '*                                                                       *
63086 '*     Eingabe: Channel ->     0 ... 2                                   *
63087 '*                 Part -> +/- 1 ... 8 startet den Kanal                 *
63088 '*                                     sonst  stummschalten              *
63089 '*                                                                       *
63090 '*************************************************************************
63091 '
63092 DEF PROC Swk_Play(Channel%,Part%)
63093 '
63094    IF Channel%>=0 AND Channel%<=2 THEN Swk_Array%(9+Channel%)=Part%
63095 '
63096 RETURN
63097 '
63098 '
63099 '
63100 '*************************************************************************
63101 '*                                                                       *
63102 '*                               SWK_TILL                                *
63103 '*                                                                       *
63104 '*     Eingabe: Channel -> 0 ... 2                                       *
63105 '*                 Last -> Anzahl der zu spielenden Takte                *
63106 '*                                                                       *
63107 '*************************************************************************
63108 '
63109 DEF PROC Swk_Till(Channel%,Last%)
63110 '
63111    IF Channel%>=0 AND Channel%<=2 THEN Swk_Array%(12+Channel%)=Last%
63112 '
63113 RETURN
63114 '
63115 '
63116 '*************************************************************************
63117 '*                                                                       *
63118 '*                               SWK_EXEC                                *
63119 '*                                                                       *
63120 '*   Eingabe: Channel -> 0 ... 2                                         *
63121 '*              Begin -> Taktnummer zum Starten der Routine              *
63122 '*            Routine -> Startadresse der Routine                        *
63123 '*                                                                       *
63124 '*************************************************************************
63125 '
63126 DEF PROC Swk_Exec(Channel%,Begin%,Routine%L)
63127 '
63128    IF Channel%>=0 AND Channel%<=2 THEN
63129       Swk_Array%(12+Channel%)=Begin%
63130       Channel%=Channel%+Channel%
63131       Swk_Array%(15+Channel%)= HIGH(Routine%L)
63132       Swk_Array%(16+Channel%)= LOW(Routine%L)
63133    ENDIF
63134 '
63135 RETURN
63136 '
63137 '
63138 '
63139 '*************************************************************************
63140 '*                                                                       *
63141 '*                               SWK_TIME                                *
63142 '*                                                                       *
63143 '*        Eingabe: channel -> 0 ... 2                                    *
63144 '*                                                                       *
63145 '*        Ausgabe: momentan gespielter Takt oder Null, wenn stumm        *
63146 '*                 -1: ungltige Kanalnummer                             *
63147 '*                                                                       *
63148 '*************************************************************************
63149 '
63150 DEF FN Swk_Time%(Channel%)
63151 '
63152    IF Channel%>=0 AND Channel%<=2 THEN
63153       RETURN Swk_Array%(9+Channel%) AND $FF
63154    ENDIF
63155 '
63156 RETURN -1
63157 '
63158 '
63159 '
63160 '*************************************************************************
63161 '*                                                                       *
63162 '*                               SWK_PART                                *
63163 '*                                                                       *
63164 '*        Eingabe: channel -> 0 ... 2                                    *
63165 '*                                                                       *
63166 '*        Ausgabe: momentan gespielter Part oder Null, wenn stumm        *
63167 '*                 -1: ungltige Kanalnummer                             *
63168 '*                                                                       *
63169 '*************************************************************************
63170 '
63171 DEF FN Swk_Part%(Channel%)
63172 '
63173    IF Channel%>=0 AND Channel%<=2 THEN RETURN Swk_Array%(9+Channel%) SHR 8
63174 '
63175 RETURN -1
63176 '
63177 '
63178 '
63179 '*************************************************************************
63180 '*                                                                       *
63181 '*                               JOY_START                               *
63182 '*                                                                       *
63183 '*************************************************************************
63184 '
63185 DEF PROC Joy_Start(Joy_Mode%)
63186    '
63187    Swk_Array%(32)=Joy_Mode%
63188    Swk_Ptr%L=Swk_Adr%L+56
63189    XBIOS (,38, HIGH(Swk_Ptr%L), LOW(Swk_Ptr%L))
63190    '
63191 RETURN
63192 '
63193 '
63194 '
63195 '*************************************************************************
63196 '*                                                                       *
63197 '*                               JOY_STOP                                *
63198 '*                                                                       *
63199 '*************************************************************************
63200 '
63201 DEF PROC Joy_Stop
63202    '
63203    Swk_Ptr%L=Swk_Adr%L+60
63204    XBIOS (,38, HIGH(Swk_Ptr%L), LOW(Swk_Ptr%L))
63205    '
63206 RETURN
63207 '
63208 '
63209 '
63210 '*************************************************************************
63211 '*                                                                       *
63212 '*                               JOY_LAST                                *
63213 '*                                                                       *
63214 '*************************************************************************
63215 '
63216 DEF FN Joy_Last% =Swk_Array%(21)
63217 '
63218 '
63219 '
63220 '*************************************************************************
63221 '*                                                                       *
63222 '*                                 JOY_0                                 *
63223 '*                                                                       *
63224 '*************************************************************************
63225 '
63226 DEF FN Joy_0% =Swk_Array%(22)
63227 '
63228 '
63229 '
63230 '*************************************************************************
63231 '*                                                                       *
63232 '*                                 JOY_1                                 *
63233 '*                                                                       *
63234 '*************************************************************************
63235 '
63236 DEF FN Joy_1% =Swk_Array%(23)
63237 '
63238 '
63239 '
63240 '/* EOF */

